# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class UpdateAchievement(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'title': 'str',
        'description': 'str',
        'target': 'float',
        'period': 'str',
        'period_end_override': 'TimePoint'
    }

    attribute_map = {
        'name': 'name',
        'title': 'title',
        'description': 'description',
        'target': 'target',
        'period': 'period',
        'period_end_override': 'periodEndOverride'
    }

    def __init__(self, name=None, title=None, description=None, target=None, period=None, period_end_override=None, local_vars_configuration=None):  # noqa: E501
        """UpdateAchievement - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._title = None
        self._description = None
        self._target = None
        self._period = None
        self._period_end_override = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if target is not None:
            self.target = target
        if period is not None:
            self.period = period
        if period_end_override is not None:
            self.period_end_override = period_end_override

    @property
    def name(self):
        """Gets the name of this UpdateAchievement.  # noqa: E501

        The internal name of the achievement used in API requests.   # noqa: E501

        :return: The name of this UpdateAchievement.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UpdateAchievement.

        The internal name of the achievement used in API requests.   # noqa: E501

        :param name: The name of this UpdateAchievement.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 1000):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `1000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and not re.search(r'^[a-zA-Z]\w+$', name)):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^[a-zA-Z]\w+$/`")  # noqa: E501

        self._name = name

    @property
    def title(self):
        """Gets the title of this UpdateAchievement.  # noqa: E501

        The display name for the achievement in the Campaign Manager.  # noqa: E501

        :return: The title of this UpdateAchievement.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this UpdateAchievement.

        The display name for the achievement in the Campaign Manager.  # noqa: E501

        :param title: The title of this UpdateAchievement.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this UpdateAchievement.  # noqa: E501

        A description of the achievement.  # noqa: E501

        :return: The description of this UpdateAchievement.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateAchievement.

        A description of the achievement.  # noqa: E501

        :param description: The description of this UpdateAchievement.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def target(self):
        """Gets the target of this UpdateAchievement.  # noqa: E501

        The required number of actions or the transactional milestone to complete the achievement.  # noqa: E501

        :return: The target of this UpdateAchievement.  # noqa: E501
        :rtype: float
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this UpdateAchievement.

        The required number of actions or the transactional milestone to complete the achievement.  # noqa: E501

        :param target: The target of this UpdateAchievement.  # noqa: E501
        :type: float
        """

        self._target = target

    @property
    def period(self):
        """Gets the period of this UpdateAchievement.  # noqa: E501

        The relative duration after which the achievement ends and resets for a particular customer profile.   # noqa: E501

        :return: The period of this UpdateAchievement.  # noqa: E501
        :rtype: str
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this UpdateAchievement.

        The relative duration after which the achievement ends and resets for a particular customer profile.   # noqa: E501

        :param period: The period of this UpdateAchievement.  # noqa: E501
        :type: str
        """

        self._period = period

    @property
    def period_end_override(self):
        """Gets the period_end_override of this UpdateAchievement.  # noqa: E501


        :return: The period_end_override of this UpdateAchievement.  # noqa: E501
        :rtype: TimePoint
        """
        return self._period_end_override

    @period_end_override.setter
    def period_end_override(self, period_end_override):
        """Sets the period_end_override of this UpdateAchievement.


        :param period_end_override: The period_end_override of this UpdateAchievement.  # noqa: E501
        :type: TimePoint
        """

        self._period_end_override = period_end_override

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateAchievement):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateAchievement):
            return True

        return self.to_dict() != other.to_dict()
